Index: bzfs.cxx
===================================================================
--- bzfs.cxx	(revision 20911)
+++ bzfs.cxx	(working copy)
@@ -73,8 +73,6 @@
 // or dropped us for some reason.
 static const float ListServerReAddTime = 30.0f * 60.0f;
 
-static const float FlagHalfLife = 10.0f;
-
 // do NOT change
 static const int InvalidPlayer = -1;
 
@@ -94,8 +92,7 @@
 static int maxFileDescriptor;
 // team info
 TeamInfo team[NumTeams];
-// num flags in flag list
-int numFlags;
+// ready to shutdown server?
 bool done = false;
 // true if hit time/score limit
 bool gameOver = true;
@@ -149,8 +146,7 @@
 static RejoinList rejoinList;
 
 static TimeKeeper lastWorldParmChange;
-static bool       isIdentifyFlagIn = false;
-static bool       playerHadWorld   = false;
+static bool playerHadWorld = false;
 
 bool		  publiclyDisconected = false;
 
@@ -289,7 +285,7 @@
 //
 // global variable callback
 //
-static void onGlobalChanged(const std::string& name, void*)
+void onGlobalChanged(const std::string& name, void*)
 {
   // This Callback is removed in replay mode. As
   // well, the /set and /reset commands are blocked.
@@ -304,7 +300,6 @@
   broadcastMessage(MsgSetVar, (char*)buf - (char*)bufStart, bufStart);
 }
 
-
 static void sendUDPupdate(int playerIndex)
 {
   // confirm inbound UDP with a TCP message
@@ -342,10 +337,9 @@
 {
   void *buf, *bufStart = getDirectMessageBuffer();
   buf = nboPackUShort(bufStart,1);
-  bool hide
-    = (flag.flag.type->flagTeam == ::NoTeam)
-    && !isIdentifyFlagIn
-    && (flag.player == -1);
+  bool hide = (flag.getTeamIndex() == ::NoTeam)
+              && (flag.getPlayer() == -1)
+              && !FLAGMGR.identifyFlag();
   buf = flag.pack(buf, hide);
   broadcastMessage(MsgFlagUpdate, (char*)buf - (char*)bufStart, bufStart);
 }
@@ -419,9 +413,9 @@
   buf = nboPackUShort(bufStart,0); //placeholder
   int cnt = 0;
   int length = sizeof(uint16_t);
-  for (int flagIndex = 0; flagIndex < numFlags; flagIndex++) {
-    FlagInfo &flag = *FlagInfo::get(flagIndex);
-    if (flag.exist()) {
+  for (int flagIndex = 0; flagIndex < FLAGMGR.size(); flagIndex++) {
+    FlagInfo &flag = *FLAGMGR.getFlag(flagIndex);
+    if (flag.exists()) {
       if ((length + sizeof(uint16_t) + FlagPLen)
 	  > MaxPacketLen - 2*sizeof(uint16_t)) {
 	nboPackUShort(bufStart, cnt);
@@ -434,10 +428,9 @@
 	buf    = nboPackUShort(bufStart,0); //placeholder
       }
 
-      bool hide
-	= (flag.flag.type->flagTeam == ::NoTeam)
-	&& !isIdentifyFlagIn
-	&& (flag.player == -1);
+      bool hide = (flag.getTeamIndex() == ::NoTeam)
+	          && (flag.getPlayer() == -1)
+	          && !FLAGMGR.identifyFlag();
       buf = flag.pack(buf, hide);
       length += sizeof(uint16_t)+FlagPLen;
       cnt++;
@@ -958,12 +951,12 @@
 
     if (clOptions->gameStyle & TeamFlagGameStyle) {
       for (int i = RedTeam; i <= PurpleTeam; i++) {
-	if ((clOptions->maxTeam[i] > 0) && bases.find(i) == bases.end()) {
-	  std::cerr << "base was not defined for "
-		    << Team::getName((TeamColor)i)
-		    << std::endl;
-	  return false;
-	}
+        if ((clOptions->maxTeam[i] > 0) && bases.find(i) == bases.end()) {
+          std::cerr << "base was not defined for "
+                    << Team::getName((TeamColor)i)
+                    << std::endl;
+          return false;
+        }
       }
     }
   } else {
@@ -1046,9 +1039,9 @@
     team[i].team.won = 0;
     team[i].team.lost = 0;
   }
-  FlagInfo::setNoFlagInAir();
-  for (i = 0; i < numFlags; i++) {
-    resetFlag(*FlagInfo::get(i));
+  FLAGMGR.setNoFlagInAir();
+  for (i = 0; i < FLAGMGR.size(); i++) {
+    resetFlag(*FLAGMGR.getFlag(i));
   }
 
   return true;
@@ -1917,14 +1910,14 @@
   }
 
   // if first player on team add team's flag
-  if (team[teamIndex].team.size == 1
+  if ((team[teamIndex].team.size == 1)
       && Team::isColorTeam((TeamColor)teamIndex)) {
     if (clOptions->gameStyle & int(TeamFlagGameStyle)) {
-      int flagid = FlagInfo::lookupFirstTeamFlag(teamIndex);
-      if (flagid >= 0 && !FlagInfo::get(flagid)->exist()) {
-	// reset those flags
-	for (int n = 0; n < clOptions->numTeamFlags[teamIndex]; n++)
-	  resetFlag(*FlagInfo::get(n + flagid));
+      for (int n = 0; n < FLAGMGR.size(); n++) {
+        FlagInfo& fi = *FLAGMGR.getFlag(n);
+        if (fi.getTeamIndex() == teamIndex) {
+          resetFlag(fi);
+        }
       }
     }
   }
@@ -2024,7 +2017,7 @@
   // reposition flag (middle of the map might be a bad idea)
   float flagPos[3] = {0.0f, 0.0f, 0.0f};
 
-  int teamIndex = flag.teamIndex();
+  int teamIndex = flag.getTeamIndex();
   if ((teamIndex >= ::RedTeam) &&  (teamIndex <= ::PurpleTeam)
       && (bases.find(teamIndex) != bases.end())) {
     if (!world->getFlagSpawnPoint(&flag, flagPos)) {
@@ -2065,14 +2058,15 @@
   }
 
   bool teamIsEmpty = true;
-  if (teamIndex != ::NoTeam)
+  if (teamIndex != ::NoTeam) {
     teamIsEmpty = (team[teamIndex].team.size == 0);
+  }
 
   bz_FlagResetEventData eventData;
   memcpy(eventData.pos,flagPos,sizeof(float)*3);
   eventData.teamIsEmpty = teamIsEmpty;
   eventData.flagID = flag.getIndex();
-  eventData.flagType = flag.flag.type->label().c_str();
+  eventData.flagType = flag.getFlagType()->label().c_str();
 
   // reset a flag's info
   flag.resetFlag(eventData.pos, teamIsEmpty);
@@ -2084,14 +2078,14 @@
 void sendDrop(FlagInfo &flag)
 {
   // see if someone had grabbed flag.  tell 'em to drop it.
-  const int playerIndex = flag.player;
+  const int playerIndex = flag.getPlayer();
 
   GameKeeper::Player *playerData
     = GameKeeper::Player::getPlayerByIndex(playerIndex);
   if (!playerData)
     return;
 
-  flag.player      = -1;
+  flag.setPlayer(-1);
   playerData->player.resetFlag();
 
   void *bufStart = getDirectMessageBuffer();
@@ -2110,7 +2104,7 @@
   // if flag was flying then it flies no more
   flag.landing(TimeKeeper::getSunExplodeTime());
 
-  flag.flag.status = FlagNoExist;
+  flag.setStatus(FlagNoExist);
 
   // reset flag status
   resetFlag(flag);
@@ -2119,11 +2113,14 @@
 // try to get over a bug where extraneous flag are attached to a tank
 // not really found why, but this should fix
 // Should be called when we sure that tank does not hold any
-static void dropAssignedFlag(int playerIndex) {
-  for (int flagIndex = 0; flagIndex < numFlags; flagIndex++) {
-    FlagInfo &flag = *FlagInfo::get(flagIndex);
-    if (flag.flag.status == FlagOnTank && flag.flag.owner == playerIndex)
-      resetFlag(flag);
+static void dropAssignedFlag(int playerIndex)
+{
+  for (int flagIndex = 0; flagIndex < FLAGMGR.size(); flagIndex++) {
+    FlagInfo &fi = *FLAGMGR.getFlag(flagIndex);
+    const Flag& flag = fi.getFlag();
+    if ((flag.status == FlagOnTank) && (flag.owner == playerIndex)) {
+      resetFlag(fi);
+    }
   }
 } // dropAssignedFlag
 
@@ -2226,13 +2223,12 @@
   if (flagid < 0)
     return;
 
-  FlagInfo &flag = *FlagInfo::get(flagid);
   // do not simply zap team flag
-  Flag &carriedflag = flag.flag;
-  if (carriedflag.type->flagTeam != ::NoTeam) {
+  FlagInfo &fi = *FLAGMGR.getFlag(flagid);
+  if (fi.getTeamIndex() != ::NoTeam) {
     dropPlayerFlag(*playerData, playerData->lastState.pos);
   } else {
-    zapFlag(flag);
+    zapFlag(fi);
   }
 }
 
@@ -2312,29 +2308,29 @@
     broadcastMessage(MsgRemovePlayer, (char*)buf-(char*)bufStart, bufStart);
 
     // decrease team size
-    int teamNum = int(playerData->player.getTeam());
-    --team[teamNum].team.size;
+    int teamIndex = int(playerData->player.getTeam());
+    --team[teamIndex].team.size;
 
-    // if last active player on team then remove team's flag if no one
-    // is carrying it
-    if (Team::isColorTeam((TeamColor)teamNum)
-	&& team[teamNum].team.size == 0 &&
-	(clOptions->gameStyle & int(TeamFlagGameStyle))) {
-      int flagid = FlagInfo::lookupFirstTeamFlag(teamNum);
-      if (flagid >= 0) {
-	GameKeeper::Player *otherData;
-	for (int n = 0; n < clOptions->numTeamFlags[teamNum]; n++) {
-	  FlagInfo &flag = *FlagInfo::get(flagid+n);
-	  otherData
-	    = GameKeeper::Player::getPlayerByIndex(flag.player);
-	  if (!otherData || otherData->player.isTeam((TeamColor)teamNum))
-	    zapFlag(flag);
-	}
+    // if last active player on team then, remove team's flags
+    // (unless someone is carrying them... ?)
+    if (Team::isColorTeam((TeamColor)teamIndex)
+	&& (team[teamIndex].team.size == 0)
+	&& (clOptions->gameStyle & int(TeamFlagGameStyle))) {
+      GameKeeper::Player* gkPlayer;
+      for (int n = 0; n < FLAGMGR.size(); n++) {
+        FlagInfo& fi = *FLAGMGR.getFlag(n);
+        if (fi.getTeamIndex() == teamIndex) {
+          gkPlayer = GameKeeper::Player::getPlayerByIndex(fi.getPlayer());
+          if ((gkPlayer == NULL)
+              || gkPlayer->player.isTeam((TeamColor)teamIndex)) {
+            zapFlag(fi);
+          }
+        }
       }
     }
 
     // send team update
-    sendTeamUpdate(-1, teamNum);
+    sendTeamUpdate(-1, teamIndex);
   }
 
   playerData->close();
@@ -2423,7 +2419,7 @@
   // An hack to fix a bug on the client
   buf = nboPackUShort (buf, PlayerSlot);
   buf = nboPackUShort (buf, clOptions->maxShots);
-  buf = nboPackUShort (buf, numFlags);
+  buf = nboPackUShort (buf, FLAGMGR.size());
   buf = nboPackFloat  (buf, clOptions->linearAcceleration);
   buf = nboPackFloat  (buf, clOptions->angularAcceleration);
   buf = nboPackUShort (buf, clOptions->shakeTimeout);
@@ -2538,7 +2534,7 @@
     return;
   }
 
-  bz_AllowSpawnData	spawnAllowData;
+  bz_AllowSpawnData spawnAllowData;
   spawnAllowData.playerID = playerIndex;
   spawnAllowData.team = convertTeam(playerData->player.getTeam());
 
@@ -2547,8 +2543,8 @@
     sendMessage(ServerPlayer, playerIndex, "This server may require identification before you can join.");
     sendMessage(ServerPlayer, playerIndex, "Please use /identify, or /register if you have not registerd your callsign or");
     sendMessage(ServerPlayer, playerIndex, "register on http://my.BZFlag.org/bb/ and use that callsign/password.");
-	spawnAllowData.allow = false;
-	}
+    spawnAllowData.allow = false;
+  }
 
   if (playerData->player.isBot()
       && BZDB.isTrue(StateDatabase::BZDB_DISABLEBOTS)) {
@@ -2837,7 +2833,7 @@
       playerData->player.isObserver() ||
       !playerData->player.isAlive() ||
       playerData->player.haveFlag() ||
-      flag.flag.status != FlagOnGround)
+      flag.getFlag().status != FlagOnGround)
     return;
 
   //last Pos might be lagged by TankSpeed so include in calculation
@@ -2845,7 +2841,7 @@
   const float tankSpeed = BZDBCache::tankSpeed;
   const float radius2 = (tankSpeed + tankRadius + BZDBCache::flagRadius) * (tankSpeed + tankRadius + BZDBCache::flagRadius);
   const float* tpos = playerData->lastState.pos;
-  const float* fpos = flag.flag.position;
+  const float* fpos = flag.getFlag().position;
   const float delta = (tpos[0] - fpos[0]) * (tpos[0] - fpos[0]) +
 		      (tpos[1] - fpos[1]) * (tpos[1] - fpos[1]);
 
@@ -2867,7 +2863,7 @@
 
   bz_FlagGrabbedEventData	data;
   data.flagID = flag.getIndex();
-  data.flagType = flag.flag.type->flagAbbv;
+  data.flagType = flag.getFlagType()->flagAbbv;
   memcpy(data.pos,fpos,sizeof(float)*3);
   data.playerID = playerIndex;
 
@@ -2875,7 +2871,7 @@
 
   broadcastMessage(MsgGrabFlag, (char*)buf-(char*)bufStart, bufStart);
 
-  playerData->flagHistory.add(flag.flag.type);
+  playerData->flagHistory.add(flag.getFlagType());
 }
 
 
@@ -2892,15 +2888,15 @@
   // player wants to drop flag.  we trust that the client won't tell
   // us to drop a sticky flag until the requirements are satisfied.
   const int flagIndex = drpFlag.getIndex();
-  if (drpFlag.flag.status != FlagOnTank) {
+  if (drpFlag.getFlag().status != FlagOnTank) {
     return;
   }
-  int flagTeam = drpFlag.flag.type->flagTeam;
+  int flagTeam = drpFlag.getTeamIndex();
   bool isTeamFlag = (flagTeam != ::NoTeam);
 
   // limited flags that have been fired should be disposed of
-  bool limited = clOptions->flagLimit[drpFlag.flag.type] != -1;
-  if (limited && drpFlag.numShots > 0) drpFlag.grabs = 0;
+  bool limited = clOptions->flagLimit[drpFlag.getFlagType()] != -1;
+  if (limited && (drpFlag.getShotCount() > 0)) { drpFlag.zeroGrabsLeft(); }
 
 
   const float waterLevel = world->getWaterLevel();
@@ -2918,9 +2914,9 @@
 
   if (isTeamFlag) {
     vanish = false;
-  } else if (--drpFlag.grabs <= 0) {
+  } else if (drpFlag.getGrabsLeft() <= 1) {
     vanish = true;
-    drpFlag.grabs = 0;
+    drpFlag.zeroGrabsLeft();
   } else if (!clOptions->flagsOnBuildings && (landing[2] > 0.0f)) {
     vanish = true;
   } else {
@@ -2953,7 +2949,7 @@
   if (isTeamFlag) {
     // if it is a team flag, check if there are any players left in
     // that team - if not, start the flag timeout
-    if (team[drpFlag.flag.type->flagTeam].team.size == 0) {
+    if (team[drpFlag.getTeamIndex()].team.size == 0) {
       team[flagIndex + 1].flagTimeout = TimeKeeper::getCurrent();
       team[flagIndex + 1].flagTimeout += (float)clOptions->teamFlagTimeout;
     }
@@ -2976,12 +2972,12 @@
   if (flagIndex < 0) {
     return;
   }
-  dropFlag(*FlagInfo::get(flagIndex), dropPos);
+  dropFlag(*FLAGMGR.getFlag(flagIndex), dropPos);
 
   bz_FlagDroppedEventData data;
   data.playerID = playerData.getIndex();
   data.flagID = flagIndex;
-  data.flagType = FlagInfo::get(flagIndex)->flag.type->flagAbbv;
+  data.flagType = FLAGMGR.getFlag(flagIndex)->getFlagType()->flagAbbv;
   memcpy(data.pos, dropPos, sizeof(float)*3);
 
   worldEventManager.callEvents(bz_eFlagDroppedEvent,&data);
@@ -3006,9 +3002,9 @@
   int flagIndex = playerData->player.getFlag();
   if (flagIndex < 0)
     return;
-  FlagInfo &flag = *FlagInfo::get(flagIndex);
+  FlagInfo &flag = *FLAGMGR.getFlag(flagIndex);
 
-  int teamIndex = flag.teamIndex();
+  int teamIndex = flag.getTeamIndex();
   if (teamIndex == ::NoTeam)
     return;
 
@@ -3136,20 +3132,21 @@
   }
 
   float shotSpeed = BZDB.eval(StateDatabase::BZDB_SHOTSPEED);
-  FlagInfo &fInfo = *FlagInfo::get(shooter.getFlag());
+  FlagInfo &fInfo = *FLAGMGR.getFlag(shooter.getFlag());
   // verify player flag
   if ((firingInfo.flagType != Flags::Null)
-      && (firingInfo.flagType != fInfo.flag.type)) {
+      && (firingInfo.flagType != fInfo.getFlagType())) {
     std::string fireFlag = "unknown";
     std::string holdFlag = "unknown";
     if (firingInfo.flagType) {
       fireFlag = firingInfo.flagType->flagAbbv;
     }
-    if (fInfo.flag.type) {
-      if (fInfo.flag.type == Flags::Null) {
+    const FlagType* ft = fInfo.getFlagType();
+    if (ft) {
+      if (ft == Flags::Null) {
 	holdFlag = "none";
       } else {
-	holdFlag = fInfo.flag.type->flagAbbv;
+	holdFlag = ft->flagAbbv;
       }
     }
 
@@ -3273,11 +3270,11 @@
   char message[MessageLen];
   if (shooter.haveFlag()){
 
-    fInfo.numShots++; // increase the # shots fired
+    fInfo.increaseShotCount(); // increase the # shots fired
 
-    int limit = clOptions->flagLimit[fInfo.flag.type];
+    int limit = clOptions->flagLimit[fInfo.getFlagType()];
     if (limit != -1){ // if there is a limit for players flag
-      int shotsLeft = limit -  fInfo.numShots;
+      int shotsLeft = limit - fInfo.getShotCount();
       if (shotsLeft > 0) { //still have some shots left
 	// give message each shot below 5, each 5th shot & at start
 	if (shotsLeft % 5 == 0 || shotsLeft <= 3 || shotsLeft == limit-1){
@@ -3295,7 +3292,7 @@
 	  for (int i = 0; i < 3; i ++){
 	    lastPos[i] = playerData->lastState.pos[i];
 	  }
-	  fInfo.grabs = 0; // recycle this flag now
+	  fInfo.zeroGrabsLeft(); // recycle this flag now
 	  dropPlayerFlag(*playerData, lastPos);
 	} else { // more shots fired than allowed
 	  // do nothing for now -- could return and not allow shot
@@ -3720,26 +3717,27 @@
       for (int i = 0; i < numClientFlags; i++) {
 	FlagType *fDesc;
 	buf = FlagType::unpack(buf, fDesc);
-	if (fDesc != Flags::Null)
+	if (fDesc != Flags::Null) {
 	  hasFlag[fDesc] = true;
+        }
       }
 
       /* Compare them to the flags this game might need, generating a list of missing flags */
       for (it = FlagType::getFlagMap().begin();
 	   it != FlagType::getFlagMap().end(); ++it) {
 	if (!hasFlag[it->second]) {
-	   if (clOptions->flagCount[it->second] > 0)
-	     missingFlags.insert(it->second);
-	   if ((clOptions->numExtraFlags > 0) && !clOptions->flagDisallowed[it->second])
-	     missingFlags.insert(it->second);
+	  if (FLAGMGR.isAllowedType(it->second)) {
+	    missingFlags.insert(it->second);
+          }
 	}
       }
 
       /* Pack a message with the list of missing flags */
       buf = bufStart = getDirectMessageBuffer();
       for (m_it = missingFlags.begin(); m_it != missingFlags.end(); ++m_it) {
-	if ((*m_it) != Flags::Null)
+	if ((*m_it) != Flags::Null) {
 	  buf = (*m_it)->pack(buf);
+        }
       }
       directMessage(t, MsgNegotiateFlags, (char*)buf-(char*)bufStart, bufStart);
       break;
@@ -3840,13 +3838,15 @@
       // data: flag index
       uint16_t flag;
 
-      if (invalidPlayerAction(playerData->player, t, "grab a flag"))
+      if (invalidPlayerAction(playerData->player, t, "grab a flag")) {
 	break;
+      }
 
       buf = nboUnpackUShort(buf, flag);
       // Sanity check
-      if (flag < numFlags)
-	grabFlag(t, *FlagInfo::get(flag));
+      if (flag < FLAGMGR.size()) {
+	grabFlag(t, *FLAGMGR.getFlag(flag));
+      }
       break;
     }
 
@@ -3892,8 +3892,8 @@
 
       int pFlag = playerData->player.getFlag();
       if (pFlag >= 0) {
-	FlagInfo &flag = *FlagInfo::get(pFlag);
-	if (flag.flag.type == Flags::Shield) {
+	FlagInfo &flag = *FLAGMGR.getFlag(pFlag);
+	if (flag.getFlagType() == Flags::Shield) {
 	  //sendMessage(ServerPlayer, AdminPlayers, "has Shield");
 	  playerData->player.endShotCredit--;
 	}
@@ -4021,22 +4021,22 @@
 
       int flagIndex = fromData->player.getFlag();
       if (to == ServerPlayer) {
-	if (flagIndex >= 0)
-	  zapFlag (*FlagInfo::get(flagIndex));
+	if (flagIndex >= 0) {
+	  zapFlag (*FLAGMGR.getFlag(flagIndex));
+        }
 	return;
       }
 
       // Sanity check
-      if (to >= curMaxPlayers)
-	return;
+      if ((to >= curMaxPlayers) || (flagIndex == -1)) {
+        return;
+      }
 
-      if (flagIndex == -1)
-	return;
-
       GameKeeper::Player *toData
 	= GameKeeper::Player::getPlayerByIndex(to);
-      if (!toData)
+      if (!toData) {
 	return;
+      }
 
       // verify that the player stealing HAS thief
       int toPlayersFlag = toData->player.getFlag();
@@ -4044,9 +4044,9 @@
       if (!toData->player.haveFlag())
 	cheater = true;
 
-      FlagInfo *toFlag = FlagInfo::get(toPlayersFlag);
+      FlagInfo *toFlag = FLAGMGR.getFlag(toPlayersFlag);
       // without flag or with a non thief flag? Then is probably cheating
-      if (!toFlag || toFlag->flag.type != Flags::Thief)
+      if (!toFlag || toFlag->getFlagType() != Flags::Thief)
 	cheater = true;
 
       // TODO, check thief radius here
@@ -4072,17 +4072,18 @@
 
       if (ftEventData.action != ftEventData.CancelSteal) {
 	int oFlagIndex = toData->player.getFlag();
-	if (oFlagIndex >= 0)
-	  zapFlag (*FlagInfo::get(oFlagIndex));
+	if (oFlagIndex >= 0) {
+	  zapFlag(*FLAGMGR.getFlag(oFlagIndex));
+        }
       }
 
       if (ftEventData.action == ftEventData.ContinueSteal) {
 	void *obufStart = getDirectMessageBuffer();
 	void *obuf = nboPackUByte(obufStart, from);
 	obuf = nboPackUByte(obuf, to);
-	FlagInfo &flag = *FlagInfo::get(flagIndex);
-	flag.flag.owner = to;
-	flag.player = to;
+        FlagInfo &flag = *FLAGMGR.getFlag(flagIndex);
+        flag.setOwner(to);
+        flag.setPlayer(to);
 	toData->player.resetFlag();
 	toData->player.setFlag(flagIndex);
 	fromData->player.resetFlag();
@@ -4301,14 +4302,14 @@
 	    // if tank is not alive cannot be sure it didn't just toss
 	    // (V)
 	    if (pFlag >= 0) {
-	      FlagInfo &flag = *FlagInfo::get(pFlag);
-	      if (flag.flag.type == Flags::Velocity)
+	      const FlagType* ft = FLAGMGR.getFlag(pFlag)->getFlagType();
+	      if (ft == Flags::Velocity)
 		maxPlanarSpeed *= BZDB.eval(StateDatabase::BZDB_VELOCITYAD);
-	      else if (flag.flag.type == Flags::Thief)
+	      else if (ft == Flags::Thief)
 		maxPlanarSpeed *= BZDB.eval(StateDatabase::BZDB_THIEFVELAD);
-	      else if (flag.flag.type == Flags::Agility)
+	      else if (ft == Flags::Agility)
 		maxPlanarSpeed *= BZDB.eval(StateDatabase::BZDB_AGILITYADVEL);
-	      else if ((flag.flag.type == Flags::Burrow) &&
+	      else if ((ft == Flags::Burrow) &&
 		(playerData->lastState.pos[2] == state.pos[2]) &&
 		(playerData->lastState.velocity[2] == state.velocity[2]) &&
 		(state.pos[2] <= BZDB.eval(StateDatabase::BZDB_BURROWDEPTH)))
@@ -4581,7 +4582,7 @@
       char message[MessageLen]
 	= "You were kicked because you were idle too long";
       sendMessage(ServerPlayer, p,  message);
-      removePlayer(p, "idling");
+      removePlayer(p, "idling", true);
       logDebugMessage(1,"Kicked player %s [%d] for idling (thresh = %f)\n",
 	     playerData.player.getCallSign(), p, clOptions->idlekickthresh);
       return;
@@ -4639,8 +4640,8 @@
 	return;
     }
     // if player is holding a flag, drop it
-    for (int j = 0; j < numFlags; j++) {
-      if (FlagInfo::get(j)->player == p) {
+    for (int j = 0; j < FLAGMGR.size(); j++) {
+      if (FLAGMGR.getFlag(j)->getPlayer() == p) {
 	dropPlayerFlag(playerData, playerData.lastState.pos);
 	// Should recheck if player is still available
 	if (!GameKeeper::Player::getPlayerByIndex(p))
@@ -4794,8 +4795,6 @@
   setvbuf(stderr, (char *)NULL, _IOLBF, 0);
 #endif
 
-  Record::init();
-
   // check time bomb
   if (timeBombBoom()) {
     std::cerr << "This release expired on " << timeBombString() << ".\n";
@@ -4810,6 +4809,9 @@
   }
 
   // initialize
+  Flags::init();
+  Record::init();
+
 #if defined(_WIN32)
   {
     static const int major = 2, minor = 2;
@@ -4838,7 +4840,6 @@
 
   bzfsrand(time(0));
 
-  Flags::init();
 
   clOptions = new CmdLineOptions();
 
@@ -4911,17 +4912,22 @@
 
   // make flags, check sanity, etc...
   // (do this after the world has been loaded)
-  finalizeParsing(argc, argv, *clOptions, world->getEntryZones());
-  {
-    FlagInfo::setNoFlagInAir();
-    for (int i = 0; i < numFlags; i++) {
-      resetFlag(*FlagInfo::get(i));
+  finalizeParsing(argc, argv, *clOptions);
+  
+  // setup the initial flag slots
+  FLAGMGR.finalize();
+  FLAGMGR.setNoFlagInAir();
+  for (int i = 0; i < FLAGMGR.size(); i++) {
+    resetFlag(*FLAGMGR.getFlag(i));
+  }
+  if (debugLevel >= 3) {
+    std::vector<std::string> strvec;
+    FLAGMGR.getFlagList(strvec);
+    for (int s = 0; s < (int)strvec.size(); s++) {
+      logDebugMessage(3, "Flags:  %s\n", strvec[s].c_str());
     }
   }
 
-  // loading extra flag number
-  FlagInfo::setExtra(clOptions->numExtraFlags);
-
   // loading lag announcement thresholds
   LagInfo::setAdminLagAnnounceThreshold(clOptions->adminlagannounce);
   LagInfo::setLagAnnounceThreshold(clOptions->lagannounce);
@@ -4947,8 +4953,7 @@
     Replay::init();
 
     // we don't send flags to a client that isn't expecting them
-    numFlags = 0;
-    clOptions->numExtraFlags = 0;
+    FLAGMGR.clear();
 
     // disable the BZDB callbacks
     for (unsigned int gi = 0; gi < numGlobalDBItems; ++gi) {
@@ -5082,9 +5087,6 @@
     world->getWorldWeapons().clear();
   }
 
-  TimeKeeper nextSuperFlagInsertion = TimeKeeper::getCurrent();
-  const float flagExp = -logf(0.5f) / FlagHalfLife;
-
   // load up the access permissions & stuff
   initGroups();
   if (passFile.size())
@@ -5092,16 +5094,6 @@
   if (userDatabaseFile.size())
     PlayerAccessInfo::readPermsFile(userDatabaseFile);
 
-  // See if an ID flag is in the game.
-  // If not, we could hide type info for all flags
-  if (clOptions->flagCount[Flags::Identify] > 0) {
-    isIdentifyFlagIn = true;
-  }
-  if ((clOptions->numExtraFlags > 0)
-      && !clOptions->flagDisallowed[Flags::Identify]) {
-    isIdentifyFlagIn = true;
-  }
-
   if (clOptions->startRecording) {
     Record::start(ServerPlayer);
   }
@@ -5170,12 +5162,12 @@
 
     // get time for next flag drop
     float dropTime;
-    while ((dropTime = FlagInfo::getNextDrop(tm)) <= 0.0f) {
+    while ((dropTime = FLAGMGR.getNextDrop(tm)) <= 0.0f) {
       // if any flags were in the air, see if they've landed
-      for (i = 0; i < numFlags; i++) {
-	FlagInfo &flag = *FlagInfo::get(i);
+      for (i = 0; i < FLAGMGR.size(); i++) {
+	FlagInfo &flag = *FLAGMGR.getFlag(i);
 	if (flag.landing(tm)) {
-	  if (flag.flag.status == FlagOnGround) {
+	  if (flag.getFlag().status == FlagOnGround) {
 	    sendFlagUpdate(flag);
 	  } else {
 	    resetFlag(flag);
@@ -5187,6 +5179,12 @@
       waitTime = dropTime;
     }
 
+// FIXME    
+//    const float nextFlagTime = FLAGMGR.getNextEventTime();
+//    if (nextFlagTime < waitTime) {
+//      waitTime = nextFlagTime;
+//    }
+
     // get time for next Player internal action
     GameKeeper::Player::updateLatency(waitTime);
 
@@ -5223,15 +5221,16 @@
     }
 
     // see if we are within the plug requested max wait time
-    if (waitTime > pluginMaxWait)
+    if (waitTime > pluginMaxWait) {
       waitTime = pluginMaxWait;
-
+    }
+    
     // don't wait (used by CURL and MsgEnter)
     if (dontWait) {
       waitTime = 0.0f;
       dontWait = false;
     }
-
+    
     /**************
      *  SELECT()  *
      **************/
@@ -5303,8 +5302,8 @@
 	      TeamColor vteam = player->player.getTeam();
 
 	      buf = nboPackUByte(bufStart, (uint8_t)curMaxPlayers);
-	      buf = nboPackUShort
-		(buf, uint16_t(FlagInfo::lookupFirstTeamFlag(vteam)));
+	      int firstFlag = FLAGMGR.lookupFirstTeamFlag(vteam);
+	      buf = nboPackUShort(buf, uint16_t(firstFlag));
 	      buf = nboPackUShort(buf, uint16_t(1 + (int(vteam) % 4)));
 	      directMessage(j, MsgCaptureFlag, (char*)buf - (char*)bufStart,
 			    bufStart);
@@ -5320,8 +5319,8 @@
 	  }
 
 	  // reset all flags
-	  for (int j = 0; j < numFlags; j++) {
-	    zapFlag(*FlagInfo::get(j));
+	  for (int j = 0; j < FLAGMGR.size(); j++) {
+	    zapFlag(*FLAGMGR.getFlag(j));
 	  }
 
 	  // quietly reset team scores in case of a capture during the countdown
@@ -5617,10 +5616,11 @@
 		  else if (action == "reset")
 		  {
 		logDebugMessage(1,"Poll flagreset taking action: resetting unused flags.\n");
-		for (int f = 0; f < numFlags; f++) {
-		  FlagInfo &flag = *FlagInfo::get(f);
-		  if (flag.player == -1)
+		for (int f = 0; f < FLAGMGR.size(); f++) {
+		  FlagInfo &flag = *FLAGMGR.getFlag(f);
+		  if (flag.getPlayer() == -1) {
 		    resetFlag(flag);
+                  }
 		}
 	      }
 	    } /* end if poll is successful */
@@ -5690,35 +5690,23 @@
     // check team flag timeouts
     if (clOptions->gameStyle & TeamFlagGameStyle) {
       for (i = RedTeam; i < CtfTeams; ++i) {
-	if (team[i].flagTimeout - tm < 0 && team[i].team.size == 0) {
-	  int flagid = FlagInfo::lookupFirstTeamFlag(i);
-	  if (flagid >= 0) {
-	    for (int n = 0; n < clOptions->numTeamFlags[i]; n++) {
-	      FlagInfo &flag = *FlagInfo::get(flagid + n);
-	      if (flag.exist() && flag.player == -1) {
-		logDebugMessage(1,"Flag timeout for team %d\n", i);
-		zapFlag(flag);
-	      }
-	    }
-	  }
-	}
+	if ((team[i].team.size == 0) && ((team[i].flagTimeout - tm) < 0.0f)) {
+          for (int n = 0; n < FLAGMGR.size(); n++) {
+            FlagInfo& fi = *FLAGMGR.getFlag(n);
+            if ((fi.getTeamIndex() == i)
+                && (fi.getPlayer() == -1)
+                && fi.exists()) {
+              logDebugMessage(1, "Flag timeout for team %d\n", i);
+              zapFlag(fi);
+            }
+          }
+        }
       }
     }
 
-    // maybe add a super flag (only if game isn't over)
-    if (!gameOver && clOptions->numExtraFlags > 0 && nextSuperFlagInsertion<=tm) {
-      // randomly choose next flag respawn time; halflife distribution
-      float r = float(bzfrand() + 0.01); // small offset, we do not want to wait forever
-      nextSuperFlagInsertion += -logf(r) / flagExp;
-      for (i = numFlags - clOptions->numExtraFlags; i < numFlags; i++) {
-	FlagInfo &flag = *FlagInfo::get(i);
-	if (flag.flag.type == Flags::Null) {
-	  // flag in now entering game
-	  flag.addFlag();
-	  sendFlagUpdate(flag);
-	  break;
-	}
-      }
+    // possibly add random flags
+    if (!gameOver) {
+      FLAGMGR.addRandomFlags(tm);
     }
 
     // occasionally add ourselves to the list again (in case we were
@@ -5811,7 +5799,7 @@
       if (NetHandler::anyUDPPending())
 	NetHandler::flushAllUDP();
     }
-
+    
     // Fire world weapons
     world->getWorldWeapons().fire();
 
@@ -5859,7 +5847,6 @@
 
   // free misc stuff
   delete clOptions; clOptions = NULL;
-  FlagInfo::setSize(0);
   delete world; world = NULL;
   delete[] worldDatabase; worldDatabase = NULL;
   delete votingarbiter; votingarbiter = NULL;
Index: EntryZones.h
===================================================================
--- EntryZones.h	(revision 20911)
+++ EntryZones.h	(working copy)
@@ -34,7 +34,6 @@
     EntryZones();
 
     void addZone( const CustomZone *zone );
-    void addZoneFlag(int zone, int flagId);
 
     void calculateQualifierLists();
 
@@ -56,7 +55,7 @@
     QualifierMap qmap;
 
     void makeSplitLists (int zone,
-			 std::vector<FlagType*> &flags,
+			 std::vector<const FlagType*> &flags,
 			 std::vector<TeamColor> &teams,
 			 std::vector<TeamColor> &safety) const;
 };
